import $ from 'jquery';
import {X, Y, LEFT, RIGHT, CENTER} from './constants';

export default class Corner {
	constructor(corner, forceY) {
		corner = ('' + corner).replace(/([A-Z])/, ' $1').replace(/middle/gi, CENTER).toLowerCase();
		this.x = (corner.match(/left|right/i) || corner.match(/center/) || ['inherit'])[0].toLowerCase();
		this.y = (corner.match(/top|bottom|center/i) || ['inherit'])[0].toLowerCase();
		this.forceY = !!forceY;

		var f = corner.charAt(0);
		this.precedance = (f === 't' || f === 'b' ? Y : X);
	}

	invert(z, center) {
		this[z] = this[z] === LEFT ? RIGHT : this[z] === RIGHT ? LEFT : center || this[z];
	}

	string(join) {
		var x = this.x, y = this.y;

		var result = x !== y ?
			(x === 'center' || y !== 'center' && (this.precedance === Y || this.forceY) ? 
				[y,x] : [x,y]
			) :
		[x];

		return join !== false ? result.join(' ') : result;
	}

	abbrev() {
		var result = this.string(false);
		return result[0].charAt(0) + (result[1] && result[1].charAt(0) || '');
	}

	clone() {
		return new Corner( this.string(), this.forceY );
	}
}
